Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -1,11 +1,10 @@
 //////////////////////////////////////////////////////////////////////////////////
-// File     : fat32.c 
-// Date     : 01/09/2013
-// Authors  : Marco Jankovic, Cesar Fuguet & Alain Greiner
+// Date     : 01/06/2015
+// Authors  : Alain Greiner
 // Copyright (c) UPMC-LIP6
 //////////////////////////////////////////////////////////////////////////////////
 // The fat32.h and fat32.c files define a library of access functions
-// to a FAT32 disk on a block device. It is intended to be used
-// by the GIET_VM nano-kernel for both the boot code and the kernel code.
+// to a FAT32 disk on a block device. It is intended to be used by both 
+// the boot code and the kernel code.
 //////////////////////////////////////////////////////////////////////////////////
 // Implementation notes:
@@ -13,6 +12,22 @@
 //    the block device. The physical sector size is supposed to be 512 bytes.
 // 2. the "cluster" variable is actually a cluster index. A cluster contains
-//    typically 8 sectors (4K bytes) and the cluster index is a 32 bits word.
-// 3. This FAT32 library uses a FAT cache whose storage capacity is one sector.
+//    8 sectors (4K bytes) and the cluster index is a 32 bits word.
+// 3. Each file or directory referenced by the software is represented
+//    by an "inode". The set of "inodes" is organised as a tree, that is 
+//    a sub-tree of the complete file system existing on the block device.
+// 4. A given file can be referenced by several software tasks, and each task
+//    will use a private handler, called a "file descriptor", allocated by the OS
+//    when the task open the file, that is organised as an indexed array.
+// 5. This FAT32 library implements (N+1) caches : one private "File_ Cache" 
+//    for each referenced file or directory, and a specific "Fat_Cache" for 
+//    the FAT itself. Each cache contain a variable number of clusters that are
+//    dynamically allocated when they are accessed, and organised as a 64-Tree.
+//////////////////////////////////////////////////////////////////////////////////
+// General Debug Policy:
+// The global variable GIET_DEBUG_FAT is defined in the giet_config.h file.
+// The debug is activated if (proctime > GIET_DEBUG_FAT) && (GIET_DEBUG_FAT != 0)
+// The GIET_DEBUG_FAT bit 0 defines the level of debug:
+//    if   (GIET_DEBUG_FAT & 0x1)    => detailed debug 
+//    else                           => external functions only
 //////////////////////////////////////////////////////////////////////////////////
 
@@ -22,4 +37,5 @@
 #include <utils.h>
 #include <vmem.h>
+#include <kernel_malloc.h>
 #include <bdv_driver.h>
 #include <hba_driver.h>
@@ -30,25 +46,564 @@
 
 //////////////////////////////////////////////////////////////////////////////////
-//      Global variable : internal FAT representation
-//////////////////////////////////////////////////////////////////////////////////
-
-extern fat32_fs_t _fat;
-
-extern unsigned int _ptabs_vaddr[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
-  
+//               Global variables 
+//////////////////////////////////////////////////////////////////////////////////
+
+// Fat-Descriptor
+__attribute__((section(".kdata")))
+fat_desc_t _fat __attribute__((aligned(64))); 
+
+// buffer used by boot code as a simple cache when scanning FAT
+__attribute__((section(".kdata")))
+unsigned char  _fat_buffer_fat[4096] __attribute__((aligned(64)));
+
+// buffer used by boot code as a simple cache when scanning a directory in DATA region
+__attribute__((section(".kdata")))
+unsigned char  _fat_buffer_data[4096] __attribute__((aligned(64)));
+
+// lba of cluster in fat_buffer_fat
+__attribute__((section(".kdata")))
+unsigned int   _fat_buffer_fat_lba;
+
+// lba of cluster in fat_buffer_data 
+__attribute__((section(".kdata")))
+unsigned int   _fat_buffer_data_lba;
+
+//////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////
+//                  Static functions declaration
+//////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////
+
+
+///////////////////////////////////////////////////////////////////////////////////
+// This debug function displays the content of a 512 bytes buffer "buf",
+// with an identifier defined by the "string" and "block_id" arguments.
+///////////////////////////////////////////////////////////////////////////////////
+
+#if GIET_DEBUG_FAT
+static void _display_one_block( unsigned char* buf,
+                                char*          string,
+                                unsigned int   block_id );
+#endif
+
+//////////////////////////////////////////////////////////////////////////////////
+// This debug function displays the FAT descriptor. 
+//////////////////////////////////////////////////////////////////////////////////
+
+#if GIET_DEBUG_FAT
+static void _display_fat_descriptor();
+#endif
+
 /////////////////////////////////////////////////////////////////////////////////
-// This function computes the memory buffer physical address, and calls 
-// the proper IOC driver depending on the subtype (BDV / HBA / SDC / SPI / RDK). 
-// The use_irq argument allows to activate the descheduling mode, if it 
-// supported by the IOC driver subtype
+// This debug function displays the sequence of clusters allocated to a 
+// file (or directory) identified by the "inode" argument.
 /////////////////////////////////////////////////////////////////////////////////
-// Return 0 in case of success, return -1 in case of error
+
+#if GIET_DEBUG_FAT
+static void _display_clusters_list( fat_inode_t* inode );
+#endif
+
 /////////////////////////////////////////////////////////////////////////////////
-static
-int _fat_ioc_access( unsigned int use_irq,
-                     unsigned int to_mem,
-                     unsigned int lba,
-                     unsigned int buf_vaddr,
-                     unsigned int count ) 
+// The following function transfers one or several blocks between the device 
+// and a memory buffer identified by a virtual address.
+// It computes the memory buffer physical address, and calls the proper 
+// IOC driver depending on the subtype (BDV / HBA / SDC / SPI / RDK). 
+// The use_irq argument allows to activate the descheduling mode,
+// if it supported by the IOC driver subtype
+// It returns O  in case of success.
+// It returns -1 in case of error.
+/////////////////////////////////////////////////////////////////////////////////
+
+static int _fat_ioc_access( unsigned int use_irq,
+                            unsigned int to_mem,
+                            unsigned int lba,
+                            unsigned int buf_vaddr,
+                            unsigned int count );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function returns in the "desc" argument a pointer on a buffer 
+// descriptor contained in a File_Cache, or in the Fat_Cache. 
+// The searched buffer is idenfified by the "inode" and "cluster_id" arguments.
+// If the "inode" pointer is not NULL, the searched cache is a File-Cache.
+// If the "inode" pointer is NULL, the searched cache is the Fat-Cache, 
+// The "cluster_id" argument is the buffer index in the file (or in the FAT). 
+// In case of miss, it allocate a 4 Kbytes buffer and a cluster descriptor 
+// from the local kernel heap, and calls the _fat_ioc_access() function to load 
+// the missing cluster from the block device.
+// It returns O  in case of success.
+// It returns 1 in case of error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_buffer_from_cache( fat_inode_t*        inode,
+                                            unsigned int        cluster_id,
+                                            fat_cache_desc_t**  desc );
+
+////////////////////////////////////////////////////////////////////////////////
+// This function extract a (partial) name from a LFN directory entry.
+////////////////////////////////////////////////////////////////////////////////
+
+static void _get_name_from_long( unsigned char* buffer, 
+                                 char*          name );
+
+////////////////////////////////////////////////////////////////////////////////
+// The following function extract a name from a NORMAL directory entry.
+////////////////////////////////////////////////////////////////////////////////
+
+static void _get_name_from_short( unsigned char* buffer,
+                                  char*          name );
+
+//////////////////////////////////////////////////////////////////////////////////
+// This function returns the number of levels of a File-Cache (or Fat-Cache)
+// from the size of the file (or FAT).
+//////////////////////////////////////////////////////////////////////////////////
+
+static inline unsigned int _get_levels_from_size( unsigned int size );
+
+///////////////////////////////////////////////////////////////////////////////////
+// The following function analyses the "pathname" argument, from the character 
+// defined by the "nb_read" argument.
+// It copies the found name in the "name" buffer (without '/'), 
+// and updates the "nb_read" argument.
+// It returns 0 if success.
+// It returns 1 if one name length > NAME_MAX_SIZE characters
+///////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_name_from_path( char*          pathname,
+                                         char*          name,
+                                         unsigned int*  nb_read );
+
+////////////////////////////////////////////////////////////////////////////////
+// The following function scan the "pathname" argument, and copies in the
+// "name" buffer the last name in path (leaf name).
+// It returns 0 if success.
+// It returns 1 if one name length > NAME_MAX_SIZE characters
+////////////////////////////////////////////////////////////////////////////////
+static unsigned int _get_last_name( char*   pathname,
+                                    char*   name );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function access the Fat-Cache and returns in the "value"
+// argument the content of the FAT slot identified by the "cluster" argument.
+// It loads the missing cluster from block device into cache in case of miss.
+// It returns 0 if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_fat_entry( unsigned int  cluster,
+                                    unsigned int* value );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function writes a new "value" in the Fat-Cache, in the slot 
+// identified by the "cluster" argument.  
+// It loads the missing cluster from block device into cache in case of miss.
+// It returns 0 if success,
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _set_fat_entry( unsigned int  cluster,
+                                    unsigned int  value );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function introduces the inode identified by the "child" argument,
+// as a new child of the "parent" inode in the Inode-Tree.
+// All checking are supposed to be done by the caller.
+// Nor the File-Cache, neither the block device are modified.
+//////////////////////////////////////////////////////////////////////////////////
+
+static void _add_inode_in_tree( fat_inode_t*  child,
+                                fat_inode_t*  parent );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function removes one inode identified by the "inode" argument 
+// from the Inode-Tree. All checking are supposed to be done by the caller.
+// Nor the File-Cache, neither the block device are modified.
+//////////////////////////////////////////////////////////////////////////////////
+
+static void _remove_inode_from_tree( fat_inode_t* inode );
+
+//////////////////////////////////////////////////////////////////////////////////
+// This recursive function scan one File-Cache (or Fat-Cache) from root to leaves,
+// to writes all dirty clusters to block device, and reset the dirty bits.
+// The cache is identified by the "root" an "levels" arguments.
+// The "string" argument is only used for debug : inode name or Fat.
+// It returns 0 if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _update_device_from_cache( unsigned int      levels,
+                                               fat_cache_node_t* root,
+                                               char*             string );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function access directly the FS_INFO block on the block device, 
+// to update the "first_free_cluster" and "free_clusters_number" values,
+// using only the Fat-Descriptor single block buffer.
+// It return 0 in case of success.
+// It return 1 in case of error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _update_fs_info();
+
+//////////////////////////////////////////////////////////////////////////////
+// The following function read a data field (from one to four bytes) 
+// from an unsigned char[] buffer, taking endianness into account. 
+// The analysed field is defined by the "offset" and "size" arguments.
+//////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _read_entry( unsigned int    offset,
+                                 unsigned int    size,
+                                 unsigned char*  buffer,
+                                 unsigned int    little_indian );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function returns the lba of first sector in DATA region 
+// from the cluster index. The cluster index must be larger than 2. 
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _cluster_to_lba( unsigned int cluster );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function returns in the "nb_entries" argument the number of files
+// (or directories) contained in a directory identidied by the "inode " pointer.
+// It returns  0 if success.
+// It returns  1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_nb_entries( fat_inode_t*   inode,
+                                     unsigned int*  nb_entries );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function search in the directory identified by the "parent"
+// inode pointer a child (file or directory) identified by its "name".
+// It returns in the "inode" argument the searched child inode pointer.
+// If the searched name is not found in the Inode-Tree, the function access
+// the "file_cache" associated to the parent directory.
+// If the child exist on block device, the Inode-Tree is updated, and
+// a success code is returned.
+// If the file/dir does not exist on block device, a error code is returned.
+// It returns 0 if inode found.
+// It returns 1 if inode not found.
+// It returns 2 if error in cache access.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_child_from_parent( fat_inode_t*   parent,
+                                            char*          name,
+                                            fat_inode_t**  inode ); 
+
+/////////////////////////////////////////////////////////////////////////////////
+// For a file (or a directory) identified by the "pathname" argument, the
+// following function returns in the "inode" argument the inode pointer 
+// associated to the searched file (or directory), with code (0).
+// If the searched file (or directory) is not found, but the parent directory 
+// is found, it returns in the "inode" argument the pointer on the parent inode,
+// with code (1).  Finally, code (2) and code (3) are error codes.
+// Both the Inode-Tree and the involved Cache-Files are updated from the block
+// device in case of miss on one inode during the search in path.
+// Neither the Fat-Cache, nor the block device are updated.
+// It returns 0 if searched inode found
+// It returns 1 if searched inode not found but parent directory found
+// It returns 2 if searched inode not found and parent directory not found
+// It returns 3 if one name too long
+/////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _get_inode_from_path( char*          pathname,
+                                          fat_inode_t**  inode );
+
+//////////////////////////////////////////////////////////////////////////////////
+// This function computes the length and the number of LFN entries required
+// to store a node name in the "length" and "nb_lfn" arguments.
+// Short name (less than 13 characters) require 1 LFN entry.
+// Medium names (from 14 to 26 characters require 2 LFN entries.
+// Large names (up to 31 characters) require 3 LFN entries. 
+// It returns 0 if success.
+// It returns 1 if length larger than 31 characters.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _check_name_length( char* name,
+                                        unsigned int* length,
+                                        unsigned int* nb_lfn );
+
+//////////////////////////////////////////////////////////////////////////////////
+// For a node identified by the "inode" argument, this function updates the
+// "size" and "cluster" values in the entry of the parent directory File-Cache.
+// It set the dirty bit in the modified buffer of the parent directory File-Cache.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _update_dir_entry( fat_inode_t*  inode );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function add new "child" in Cache-File of "parent" directory.
+// It access the File_Cache associated to the parent directory, and scan the
+// clusters allocated to this directory to find the NO_MORE entry.
+// This entry will be the first modified entry in the directory.
+// Regarding the name storage, it uses LFN entries for all names. 
+// Therefore, it writes 1, 2, or 3 LFN entries (depending on the child name
+// actual length, it writes one NORMAL entry, and writes the new NOMORE entry.
+// It updates the dentry field in the child inode.
+// It set the dirty bit for all modified File-Cache buffers.
+// The block device is not modified by this function.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _add_dir_entry( fat_inode_t* child,
+                                    fat_inode_t* parent );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function invalidates all dir_entries associated to the "inode"
+// argument from its parent directory.
+// It set the dirty bit for all modified buffers in parent directory Cache-File.
+// The inode itself is not modified by this function.
+// The block device is not modified by this function.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _remove_dir_entry( fat_inode_t*  inode );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function add the special entries "." and ".." in the File-Cache
+// of the directory identified by the "child" argument.
+// The parent directory is defined by the "parent" argument.
+// The child directory File-Cache is supposed to be empty.
+// We use two NORMAL entries for these "." and ".." entries.
+// The block device is not modified by this function.
+//////////////////////////////////////////////////////////////////////////////////
+
+static void _add_special_directories( fat_inode_t* child,
+                                      fat_inode_t* parent );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function releases all clusters allocated to a file or directory,
+// from the cluster index defined by the "cluster" argument, until the end 
+// of the FAT linked list.
+// It calls _get_fat_entry() and _set_fat_entry() functions to scan the FAT,
+// and to update the clusters chaining.
+// The FAT region on block device is updated.
+// It returns 0 if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _clusters_release( unsigned int cluster );
+
+//////////////////////////////////////////////////////////////////////////////////
+// This function allocate "nb_clusters_more" new clusters to a file (or directory)
+// identified by the "inode" pointer. It allocates also the associated buffers
+// and buffer descriptors in the Cache-File.
+// It calls _get_fat_entry() and _set_fat_entry() functions to update the
+// clusters chaining in the Cache-Fat. The FAT region on block device is updated.
+// It returns 0 if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _clusters_allocate( fat_inode_t* inode, 
+                                        unsigned int nb_clusters_current,
+                                        unsigned int nb_clusters_more );
+
+//////////////////////////////////////////////////////////////////////////////////
+// This recursive function scan one File-Cache (or Fat-Cache) from root to leaves.
+// The cache 64-Tree infrastructure is kept, but all memory allocated for 4 Kbytes 
+// buffers, and for buffer descriptors (in leaves) is released.
+// The cache is identified by the "root" an "levels" arguments.
+// It should not contain any dirty clusters.
+// It returns 0 if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _release_cache_memory( fat_cache_node_t*  root,
+                                           unsigned int       levels );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function allocates and initializes a new inode, 
+// using the values defined by the arguments.
+// If the "cache_allocate" argument is true ans empty cache is allocated.
+// The Fat-Cache is initialised as empty: all children set to NULL.
+// It returns a pointer on the new inode.
+//////////////////////////////////////////////////////////////////////////////////
+
+static fat_inode_t* _allocate_one_inode( char*        name,
+                                         unsigned int is_dir,
+                                         unsigned int cluster,
+                                         unsigned int size,
+                                         unsigned int count,
+                                         unsigned int dentry,
+                                         unsigned int cache_allocate );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function allocates one 4 Kbytes buffer and associated cluster 
+// descriptor for the file (or directory) identified by the "inode" argument,
+// and updates the Cache_File slot identified by the "cluster_id" argument. 
+// The File-Cache slot must be empty.
+// It updates the cluster descriptor, using the "cluster" argument, that is 
+// the cluster index in FAT.  The cluster descriptor dirty field is set.
+// It traverse the 64-tree Cache-file from top to bottom to find the last level.
+//////////////////////////////////////////////////////////////////////////////////
+
+static void _allocate_one_buffer( fat_inode_t*    inode,
+                                  unsigned int    cluster_id,
+                                  unsigned int    cluster );
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following function allocates one free cluster from the FAT "heap" of free 
+// clusters, and returns the cluster index in the "cluster" argument.
+// It updates the FAT slot, and the two FAT global variables: first_free_cluster,
+// and free_clusters_number.
+// It returns O if success.
+// It returns 1 if error.
+//////////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _allocate_one_cluster( unsigned int*  cluster );
+
+/////////////////////////////////////////////////////////////////////////////
+// This function remove from the file system a file or a directory 
+// identified by the "inode" argument. 
+// The remove condition must be checked by the caller.
+// The relevant lock(s) must have been taken by te caller.
+// It returns O if success.
+// It returns 1 if error.
+/////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _remove_node_from_fs( fat_inode_t* inode );
+
+/////////////////////////////////////////////////////////////////////////////
+// This function return the cluster index and the size for a file 
+// identified by the "pathname" argument, scanning directly the block
+// device DATA region.
+// It is intended to be called only by the _fat_load_no_cache() function, 
+// it does not use the dynamically allocated File Caches, but uses only
+// the 4 Kbytes _fat_buffer_data. 
+// It returns 0 if success.
+// It returns 1 if error.
+/////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _file_info_no_cache( char*          pathname,
+                                         unsigned int*  file_cluster,
+                                         unsigned int*  file_size );
+
+/////////////////////////////////////////////////////////////////////////////
+// This function scan directly the FAT region on the block device, 
+// and returns in the "next" argument the value stored in the fat slot 
+// identified by the "cluster" argument.
+// It is intended to be called only by the _fat_load_no_cache() function,
+// as it does not use the dynamically allocated Fat-Cache, but uses only 
+// the 4 Kbytes _fat_buffer_fat.
+// It returns 0 if success.
+// It returns 1 if error.
+/////////////////////////////////////////////////////////////////////////////
+
+static unsigned int _next_cluster_no_cache( unsigned int   cluster,
+                                            unsigned int*  next );
+
+
+//////////////////////////////////////////////////////////////////////////////////
+// The following functions return the length or the size of a FAT field, 
+// identified by an (offset,length) mnemonic defined in the fat32.h file.
+//////////////////////////////////////////////////////////////////////////////////
+
+static inline int get_length( int offset , int length ) { return length; }
+
+static inline int get_offset( int offset , int length ) { return offset; }
+
+
+
+
+
+//////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////
+//                  Static functions definition
+//////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////
+
+#if GIET_DEBUG_FAT
+///////////////////////////////////////////////////
+static void _display_one_block( unsigned char* buf,
+                                char*          string,
+                                unsigned int   block_id )
+{
+    unsigned int line;
+    unsigned int word;
+
+    _printf("\n***  <%s>  block %x  ***********************************\n",
+            string , block_id );
+
+    for ( line = 0 ; line < 16 ; line++ )
+    {
+        // display line index 
+        _printf("%x : ", line );
+
+        // display 8*4 bytes hexa
+        for ( word=0 ; word<8 ; word++ )
+        {
+            unsigned int byte  = (line<<5) + (word<<2);
+            unsigned int hexa  = (buf[byte  ]<<24) |
+                                 (buf[byte+1]<<16) |
+                                 (buf[byte+2]<< 8) |
+                                 (buf[byte+3]      );
+            _printf(" %X |", hexa );
+        }
+        _printf("\n");
+    }
+    _printf("*******************************************************************\n"); 
+} // end _display_one_block()  
+#endif
+
+
+
+#if GIET_DEBUG_FAT
+/////////////////////////////////////
+static void _display_fat_descriptor()
+{
+    _printf("\n###############  FAT DESCRIPTOR  ################################"  
+            "\nFAT initialised                  %x"
+            "\nBlock Size  (bytes)              %x"
+            "\nCluster Size  (bytes)            %x"
+            "\nFAT region first lba             %x"
+            "\nFAT region size (blocks)         %x"
+            "\nDATA region first lba            %x"
+            "\nDATA region size (blocks)        %x"
+            "\nNumber of free clusters          %x"
+            "\nFirst free cluster index         %x" 
+            "\nFat_cache_levels                 %d" 
+            "\n#################################################################\n",
+            _fat.initialised,
+            _fat.sector_size,
+            _fat.cluster_size,
+            _fat.fat_lba,
+            _fat.fat_sectors,
+            _fat.data_lba,
+            _fat.data_sectors,
+            _fat.free_clusters_number,
+            _fat.first_free_cluster,
+            _fat.fat_cache_levels );
+
+} // end _display_fat_descriptor()
+#endif
+
+
+
+#if GIET_DEBUG_FAT
+////////////////////////////////////////////////////////
+static void _display_clusters_list( fat_inode_t* inode )
+{
+    _printf("\n**************** clusters for <%s> ***********************\n", inode->name );
+    unsigned int next;
+    unsigned int n       = 0;
+    unsigned int current = inode->cluster;
+    while( (current < END_OF_CHAIN_CLUSTER_MIN) && (n < 1024) )
+    {
+        _get_fat_entry( current , &next );
+        _printf(" > %X", current );
+        n++;
+        if ( (n & 0x7) == 0 ) _printf("\n");
+        current = next;
+    }
+    _printf("\n");
+}  // end _display_clusters_list()
+#endif
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+static int _fat_ioc_access( unsigned int use_irq,       // descheduling if non zero
+                            unsigned int to_mem,        // read / write
+                            unsigned int lba,           // first sector on device
+                            unsigned int buf_vaddr,     // memory buffer vaddr
+                            unsigned int count )        // number of sectors
 {
     // compute memory buffer physical address
